﻿using System.Text.Json;
using System.Threading.Tasks;
using Amazon.DynamoDBv2;
using Amazon.DynamoDBv2.DocumentModel;
using DynamoDbApiDocumentModel.Models;
using Microsoft.AspNetCore.Mvc;

namespace DynamoDbApiDocumentModel.Controllers
{
    [ApiController]
    [Route("[controller]")]
    public class PersonController : ControllerBase
    {
        private readonly IAmazonDynamoDB _amazonDynamoDB;
        public PersonController(IAmazonDynamoDB amazonDynamoDB)
        {   
            _amazonDynamoDB = amazonDynamoDB;
        }

        [HttpGet("{personId}")]
        public async Task<IActionResult> Get(int personId)
        {
            Table people = Table.LoadTable(_amazonDynamoDB, "People");
            var person = JsonSerializer.Deserialize<Person> ((await people.GetItemAsync(personId)).ToJson());

            return Ok(person);
        }

        [HttpPost]
        public async Task<IActionResult> Post(Person person)
        {
            Table people = Table.LoadTable(_amazonDynamoDB, "People");
            
            var document = new Document();
            document["PersonId"] = person.PersonId;
            document["State"] = person.State;
            document["FirstName"] = person.FirstName;
            document["LastName"] = person.LastName;
            await people.PutItemAsync(document);
            
            return Created("", document.ToJson());
        }
    }
}
